PNotifierFunctionTemplate< ParmType > Class Template Referenceabstract

This is an abstract class for which a descendent is declared for every function that may be called. More...

`#include <notifier.h>`

Inheritance diagram for PNotifierFunctionTemplate< ParmType >:

## Public Member Functions

| PNotifierFunctionTemplate (void *obj)
| Create a notification function instance. More...
virtual void | Call (PObject &notifier, ParmType extra) const =0
| Execute the call to the actual notification function on the object instance contained in this object. More...
Public Member Functions inherited from PSmartObject
| PSmartObject ()
| Construct a new smart object, subject to a `PSmartPointer` instance referencing it. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

void * | object
| Object instance to receive the notification function call. More...
Protected Attributes inherited from PSmartObject
PAtomicInteger | referenceCount
| Count of number of instances of `PSmartPointer` that currently reference the object instance. More...

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Detailed Description

### template<typename ParmType>
class PNotifierFunctionTemplate< ParmType >

This is an abstract class for which a descendent is declared for every function that may be called.

The `PDECLARE_NOTIFIER` macro makes this declaration.

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes. The "pointer to a member function" capability built into C++ makes the assumption that the function name exists in an ancestor class. If you wish to call a member function name that does not exist in any ancestor class, very type unsafe casting of the member functions must be made. Some compilers will even refuse to do it at all!

To overcome this problem, as this mechanism is highly desirable for callback functions in the GUI part of the PTLib library, these classes and a macro are used to create all the classes and declarations to use polymorphism as the link between the caller, which has no knowledege of the function, and the receiver object and member function.

This is most often used as the notification of actions being take by interactors in the PTLib library.

## Constructor & Destructor Documentation

## PNotifierFunctionTemplate()

template<typename ParmType >

PNotifierFunctionTemplate< ParmType >::PNotifierFunctionTemplate | ( | void * | obj | ) |

inline

Create a notification function instance.

Parameters

  obj | Object instance on which the function will be called on.

References PNotifierFunctionTemplate< ParmType >::Call(), and PAssertNULL.

## Member Function Documentation

## Call()

template<typename ParmType >

virtual void PNotifierFunctionTemplate< ParmType >::Call | ( | PObject & | notifier,
|  | ParmType | extra
| ) |  | const

pure virtual

Execute the call to the actual notification function on the object instance contained in this object.

Parameters

  notifier | Object that is making the notification.
  extra | Extra information that may be passed to function.

Referenced by PNotifierFunctionTemplate< ParmType >::PNotifierFunctionTemplate().

## Member Data Documentation

## object

template<typename ParmType >

void* PNotifierFunctionTemplate< ParmType >::object

protected

Object instance to receive the notification function call.

The documentation for this class was generated from the following file:

- notifier.h